diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.42/src/internet/model/tcp-socket-base.h ns-3.43/src/internet/model/tcp-socket-base.h
--- ns-3.42/src/internet/model/tcp-socket-base.h	2024-05-29 15:29:46.968073100 -0700
+++ ns-3.43/src/internet/model/tcp-socket-base.h	2024-10-09 16:41:09.892655800 -0700
@@ -2,18 +2,7 @@
  * Copyright (c) 2007 Georgia Tech Research Corporation
  * Copyright (c) 2010 Adrian Sai-wah Tam
  *
- * This program is free software; you can redistribute it and/or modify
- * it under the terms of the GNU General Public License version 2 as
- * published by the Free Software Foundation;
- *
- * This program is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with this program; if not, write to the Free Software
- * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ * SPDX-License-Identifier: GPL-2.0-only
  *
  * Author: Adrian Sai-wah Tam <adrian.sw.tam@gmail.com>
  */
@@ -251,6 +240,25 @@
     TcpSocketBase(const TcpSocketBase& sock);
     ~TcpSocketBase() override;
 
+    /**
+     * \brief Tcp Packet Types
+     *
+     * Taxonomy referred from Table 1 of
+     * https://www.ietf.org/archive/id/draft-ietf-tcpm-generalized-ecn-15.txt
+     */
+    enum TcpPacketType_t
+    {
+        SYN,
+        SYN_ACK,
+        PURE_ACK,
+        WINDOW_PROBE,
+        FIN,
+        RST,
+        RE_XMT,
+        DATA,
+        INVALID
+    };
+
     // Set associated Node, TcpL4Protocol, RttEstimator to this socket
 
     /**
@@ -370,6 +378,11 @@
     /**
      * \brief Callback pointer for RTT trace chaining
      */
+    TracedCallback<Time, Time> m_srttTrace;
+
+    /**
+     * \brief Callback pointer for Last RTT trace chaining
+     */
     TracedCallback<Time, Time> m_lastRttTrace;
 
     /**
@@ -445,6 +458,13 @@
     void UpdateRtt(Time oldValue, Time newValue) const;
 
     /**
+     * \brief Callback function to hook to TcpSocketState lastRtt
+     * \param oldValue old lastRtt value
+     * \param newValue new lastRtt value
+     */
+    void UpdateLastRtt(Time oldValue, Time newValue) const;
+
+    /**
      * \brief Install a congestion control algorithm on this socket
      *
      * \param algo Algorithm to be installed
@@ -578,6 +598,20 @@
      */
     void SetPaceInitialWindow(bool paceWindow);
 
+    /**
+     * \brief Checks if a TCP packet should be ECN-capable (ECT) according to the TcpPacketType and
+     * ECN mode.
+     *
+     * Currently, only Classic ECN and DCTCP ECN modes are supported, with
+     * potential extensions for future modes (Ecnpp).
+     *
+     * \param packetType The type of the TCP packet, represented by an enum TcpPacketType.
+     * \return true if the packet is ECN-capable (ECT), false otherwise.
+     *
+     * Reference: https://www.ietf.org/archive/id/draft-ietf-tcpm-generalized-ecn-15.txt (Table 1)
+     */
+    bool IsEct(TcpPacketType_t packetType) const;
+
     // Necessary implementations of null functions from ns3::Socket
     SocketErrno GetErrno() const override;     // returns m_errno
     SocketType GetSocketType() const override; // returns socket type
@@ -608,7 +642,7 @@
     void BindToNetDevice(Ptr<NetDevice> netdevice) override; // NetDevice with my m_endPoint
 
     /**
-     * TracedCallback signature for tcp packet transmission or reception events.
+     * TracedCallback signature for TCP packet transmission or reception events.
      *
      * \param [in] packet The packet.
      * \param [in] header The TcpHeader
@@ -618,6 +652,21 @@
                                           const TcpHeader& header,
                                           const Ptr<const TcpSocketBase> socket);
 
+    /**
+     * TracedCallback signature for TCP packet retransmission events.
+     *
+     * \param [in] packet The packet.
+     * \param [in] header The TcpHeader
+     * \param [in] localAddr The local address
+     * \param [in] peerAddr The peer/remote address
+     * \param [in] socket This socket
+     */
+    typedef void (*RetransmissionCallback)(const Ptr<const Packet> packet,
+                                           const TcpHeader& header,
+                                           const Address& localAddr,
+                                           const Address& peerAddr,
+                                           const Ptr<const TcpSocketBase> socket);
+
   protected:
     // Implementing ns3::TcpSocket -- Attribute get/set
     // inherited, no need to doc
@@ -1036,11 +1085,13 @@
      * \param oldHeadSequence value of HeadSequence before ack
      * updated with SACK information
      * \param currentDelivered The number of bytes (S)ACKed
+     * \param receivedData if true indicates that data is piggybacked with ACK
      */
     virtual void ProcessAck(const SequenceNumber32& ackNumber,
                             bool scoreboardUpdated,
                             uint32_t currentDelivered,
-                            const SequenceNumber32& oldHeadSequence);
+                            const SequenceNumber32& oldHeadSequence,
+                            bool receivedData);
 
     /**
      * \brief Recv of a data, put into buffer, call L7 to get it if necessary
@@ -1050,6 +1101,20 @@
     virtual void ReceivedData(Ptr<Packet> packet, const TcpHeader& tcpHeader);
 
     /**
+     * \brief Calculate RTT sample for the ACKed packet
+     *
+     * Per RFC 6298 (Section 3),
+     * If `m_timestampsEnabled` is true, calculate RTT using timestamps option.
+     * Otherwise, return RTT as the elapsed time since the packet was transmitted.
+     * If ACKed packed was a retrasmitted packet, return zero time.
+     *
+     * \param tcpHeader the packet's TCP header
+     * \param rttHistory the ACKed packet's RTT History
+     * \returns the RTT sample
+     */
+    virtual Time CalculateRttSample(const TcpHeader& tcpHeader, const RttHistory& rttHistory);
+
+    /**
      * \brief Take into account the packet for RTT estimation
      * \param tcpHeader the packet's TCP header
      */
@@ -1119,7 +1184,8 @@
      */
     void DoRetransmit();
 
-    /** \brief Add options to TcpHeader
+    /**
+     * \brief Add options to TcpHeader
      *
      * Test each option, and if it is enabled on our side, add it
      * to the header
@@ -1206,7 +1272,8 @@
      */
     void AddOptionSack(TcpHeader& header);
 
-    /** \brief Process the timestamp option from other side
+    /**
+     * \brief Process the timestamp option from other side
      *
      * Get the timestamp and the echo, then save timestamp (which will
      * be the echo value in our out-packets) and save the echoed timestamp,
@@ -1257,8 +1324,9 @@
     /**
      * \brief Add Tags for the Socket
      * \param p Packet
+     * \param isEct Whether the packet is allowed to be ECT capable
      */
-    void AddSocketTags(const Ptr<Packet>& p) const;
+    void AddSocketTags(const Ptr<Packet>& p, bool isEct) const;
 
     /**
      * Get the current value of the receiver's offered window (RCV.WND)
@@ -1371,7 +1439,7 @@
     // Guesses over the other connection end
     bool m_isFirstPartialAck{true}; //!< First partial ACK during RECOVERY
 
-    // The following two traces pass a packet with a TCP header
+    // The following three traces pass a packet with a TCP header
     TracedCallback<Ptr<const Packet>,
                    const TcpHeader&,
                    Ptr<const TcpSocketBase>>
@@ -1379,6 +1447,13 @@
 
     TracedCallback<Ptr<const Packet>,
                    const TcpHeader&,
+                   const Address&,
+                   const Address&,
+                   Ptr<const TcpSocketBase>>
+        m_retransmissionTrace; //!< Trace of retransmitted packets
+
+    TracedCallback<Ptr<const Packet>,
+                   const TcpHeader&,
                    Ptr<const TcpSocketBase>>
         m_rxTrace; //!< Trace of received packets
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.42/src/internet/model/tcp-socket.cc ns-3.43/src/internet/model/tcp-socket.cc
--- ns-3.42/src/internet/model/tcp-socket.cc	2024-05-29 15:29:46.968073100 -0700
+++ ns-3.43/src/internet/model/tcp-socket.cc	2024-10-09 16:41:09.892655800 -0700
@@ -1,18 +1,7 @@
 /*
  * Copyright (c) 2007 INRIA
  *
- * This program is free software; you can redistribute it and/or modify
- * it under the terms of the GNU General Public License version 2 as
- * published by the Free Software Foundation;
- *
- * This program is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with this program; if not, write to the Free Software
- * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ * SPDX-License-Identifier: GPL-2.0-only
  *
  * Author: Mathieu Lacage <mathieu.lacage@sophia.inria.fr>
  */
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.42/src/internet/model/tcp-socket-factory.cc ns-3.43/src/internet/model/tcp-socket-factory.cc
--- ns-3.42/src/internet/model/tcp-socket-factory.cc	2024-05-29 15:29:46.968073100 -0700
+++ ns-3.43/src/internet/model/tcp-socket-factory.cc	2024-10-09 16:41:09.892655800 -0700
@@ -1,18 +1,7 @@
 /*
  * Copyright (c) 2007 Georgia Tech Research Corporation
  *
- * This program is free software; you can redistribute it and/or modify
- * it under the terms of the GNU General Public License version 2 as
- * published by the Free Software Foundation;
- *
- * This program is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with this program; if not, write to the Free Software
- * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ * SPDX-License-Identifier: GPL-2.0-only
  *
  * Author: Raj Bhattacharjea <raj.b@gatech.edu>
  */
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.42/src/internet/model/tcp-socket-factory.h ns-3.43/src/internet/model/tcp-socket-factory.h
--- ns-3.42/src/internet/model/tcp-socket-factory.h	2024-05-29 15:29:46.968073100 -0700
+++ ns-3.43/src/internet/model/tcp-socket-factory.h	2024-10-09 16:41:09.892655800 -0700
@@ -1,18 +1,7 @@
 /*
  * Copyright (c) 2007 Georgia Tech Research Corporation
  *
- * This program is free software; you can redistribute it and/or modify
- * it under the terms of the GNU General Public License version 2 as
- * published by the Free Software Foundation;
- *
- * This program is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with this program; if not, write to the Free Software
- * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ * SPDX-License-Identifier: GPL-2.0-only
  *
  * Author: Raj Bhattacharjea <raj.b@gatech.edu>
  */
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.42/src/internet/model/tcp-socket-factory-impl.cc ns-3.43/src/internet/model/tcp-socket-factory-impl.cc
--- ns-3.42/src/internet/model/tcp-socket-factory-impl.cc	2024-05-29 15:29:46.968073100 -0700
+++ ns-3.43/src/internet/model/tcp-socket-factory-impl.cc	2024-10-09 16:41:09.892655800 -0700
@@ -1,18 +1,7 @@
 /*
  * Copyright (c) 2007 Georgia Tech Research Corporation
  *
- * This program is free software; you can redistribute it and/or modify
- * it under the terms of the GNU General Public License version 2 as
- * published by the Free Software Foundation;
- *
- * This program is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with this program; if not, write to the Free Software
- * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ * SPDX-License-Identifier: GPL-2.0-only
  *
  * Author: Raj Bhattacharjea <raj.b@gatech.edu>
  */
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.42/src/internet/model/tcp-socket-factory-impl.h ns-3.43/src/internet/model/tcp-socket-factory-impl.h
--- ns-3.42/src/internet/model/tcp-socket-factory-impl.h	2024-05-29 15:29:46.968073100 -0700
+++ ns-3.43/src/internet/model/tcp-socket-factory-impl.h	2024-10-09 16:41:09.892655800 -0700
@@ -1,18 +1,7 @@
 /*
  * Copyright (c) 2007 Georgia Tech Research Corporation
  *
- * This program is free software; you can redistribute it and/or modify
- * it under the terms of the GNU General Public License version 2 as
- * published by the Free Software Foundation;
- *
- * This program is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with this program; if not, write to the Free Software
- * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ * SPDX-License-Identifier: GPL-2.0-only
  *
  * Author: Raj Bhattacharjea <raj.b@gatech.edu>
  */
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.42/src/internet/model/tcp-socket.h ns-3.43/src/internet/model/tcp-socket.h
--- ns-3.42/src/internet/model/tcp-socket.h	2024-05-29 15:29:46.968073100 -0700
+++ ns-3.43/src/internet/model/tcp-socket.h	2024-10-09 16:41:09.892655800 -0700
@@ -2,18 +2,7 @@
  * Copyright (c) 2006 Georgia Tech Research Corporation
  *               2007 INRIA
  *
- * This program is free software; you can redistribute it and/or modify
- * it under the terms of the GNU General Public License version 2 as
- * published by the Free Software Foundation;
- *
- * This program is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with this program; if not, write to the Free Software
- * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ * SPDX-License-Identifier: GPL-2.0-only
  *
  * Authors: George F. Riley<riley@ece.gatech.edu>
  *          Mathieu Lacage <mathieu.lacage@sophia.inria.fr>
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.42/src/internet/model/tcp-socket-state.cc ns-3.43/src/internet/model/tcp-socket-state.cc
--- ns-3.42/src/internet/model/tcp-socket-state.cc	2024-05-29 15:29:46.968073100 -0700
+++ ns-3.43/src/internet/model/tcp-socket-state.cc	2024-10-09 16:41:09.892655800 -0700
@@ -1,18 +1,7 @@
 /*
  * Copyright (c) 2018 Natale Patriciello <natale.patriciello@gmail.com>
  *
- * This program is free software; you can redistribute it and/or modify
- * it under the terms of the GNU General Public License version 2 as
- * published by the Free Software Foundation;
- *
- * This program is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with this program; if not, write to the Free Software
- * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ * SPDX-License-Identifier: GPL-2.0-only
  */
 #include "tcp-socket-state.h"
 
@@ -91,7 +80,11 @@
                             MakeTraceSourceAccessor(&TcpSocketState::m_bytesInFlight),
                             "ns3::TracedValueCallback::Uint32")
             .AddTraceSource("RTT",
-                            "Last RTT sample",
+                            "Smoothed RTT",
+                            MakeTraceSourceAccessor(&TcpSocketState::m_srtt),
+                            "ns3::TracedValueCallback::Time")
+            .AddTraceSource("LastRTT",
+                            "RTT of the last (S)ACKed packet",
                             MakeTraceSourceAccessor(&TcpSocketState::m_lastRtt),
                             "ns3::TracedValueCallback::Time");
     return tid;
@@ -120,6 +113,7 @@
       m_minRtt(other.m_minRtt),
       m_bytesInFlight(other.m_bytesInFlight),
       m_isCwndLimited(other.m_isCwndLimited),
+      m_srtt(other.m_srtt),
       m_lastRtt(other.m_lastRtt),
       m_ecnMode(other.m_ecnMode),
       m_useEcn(other.m_useEcn),
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.42/src/internet/model/tcp-socket-state.h ns-3.43/src/internet/model/tcp-socket-state.h
--- ns-3.42/src/internet/model/tcp-socket-state.h	2024-05-29 15:29:46.968073100 -0700
+++ ns-3.43/src/internet/model/tcp-socket-state.h	2024-10-09 16:41:09.892655800 -0700
@@ -1,18 +1,7 @@
 /*
  * Copyright (c) 2018 Natale Patriciello <natale.patriciello@gmail.com>
  *
- * This program is free software; you can redistribute it and/or modify
- * it under the terms of the GNU General Public License version 2 as
- * published by the Free Software Foundation;
- *
- * This program is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with this program; if not, write to the Free Software
- * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ * SPDX-License-Identifier: GPL-2.0-only
  */
 #ifndef TCP_SOCKET_STATE_H
 #define TCP_SOCKET_STATE_H
@@ -206,9 +195,10 @@
 
     Time m_minRtt{Time::Max()}; //!< Minimum RTT observed throughout the connection
 
-    TracedValue<uint32_t> m_bytesInFlight{0};  //!< Bytes in flight
-    bool m_isCwndLimited{false};               //!< Whether throughput is limited by cwnd
-    TracedValue<Time> m_lastRtt{Seconds(0.0)}; //!< Last RTT sample collected
+    TracedValue<uint32_t> m_bytesInFlight{0}; //!< Bytes in flight
+    bool m_isCwndLimited{false};              //!< Whether throughput is limited by cwnd
+    TracedValue<Time> m_srtt;                 //!< Smoothed RTT
+    TracedValue<Time> m_lastRtt;              //!< RTT of the last (S)ACKed packet
 
     Ptr<TcpRxBuffer> m_rxBuffer; //!< Rx buffer (reordering buffer)
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.42/src/internet/model/tcp-tx-buffer.cc ns-3.43/src/internet/model/tcp-tx-buffer.cc
--- ns-3.42/src/internet/model/tcp-tx-buffer.cc	2024-05-29 15:29:46.968073100 -0700
+++ ns-3.43/src/internet/model/tcp-tx-buffer.cc	2024-10-09 16:41:09.892655800 -0700
@@ -2,18 +2,7 @@
  * Copyright (c) 2010-2015 Adrian Sai-wah Tam
  * Copyright (c) 2016 Natale Patriciello <natale.patriciello@gmail.com>
  *
- * This program is free software; you can redistribute it and/or modify
- * it under the terms of the GNU General Public License version 2 as
- * published by the Free Software Foundation;
- *
- * This program is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with this program; if not, write to the Free Software
- * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ * SPDX-License-Identifier: GPL-2.0-only
  *
  * Original author: Adrian Sai-wah Tam <adrian.sw.tam@gmail.com>
  */
@@ -174,6 +163,7 @@
 
     // if you change the head with data already sent, something bad will happen
     NS_ASSERT(m_sentList.empty());
+    m_sackSeen = false;
     m_highestSack = std::make_pair(m_sentList.end(), SequenceNumber32(0));
 }
 
@@ -767,6 +757,7 @@
 
     if (m_highestSack.second <= m_firstByteSeq)
     {
+        m_sackSeen = false;
         m_highestSack = std::make_pair(m_sentList.end(), SequenceNumber32(0));
     }
 
@@ -831,6 +822,7 @@
                     if (m_highestSack.first == m_sentList.end() ||
                         m_highestSack.second <= beginOfCurrentPacket + pktSize)
                     {
+                        m_sackSeen = true;
                         m_highestSack = std::make_pair(item_it, beginOfCurrentPacket);
                     }
 
@@ -983,7 +975,8 @@
         item = *it;
 
         // Condition 1.a , 1.b , and 1.c
-        if (!item->m_retrans && !item->m_sacked)
+        if (!item->m_retrans && !item->m_sacked &&
+            ((m_sackSeen && item->m_startSeq < m_highestSack.second) || !m_sackSeen))
         {
             if (item->m_lost)
             {
@@ -1213,6 +1206,7 @@
     }
 
     m_highestSack = std::make_pair(m_sentList.end(), SequenceNumber32(0));
+    m_sackSeen = false;
 }
 
 void
@@ -1241,6 +1235,7 @@
     m_lostOut = 0;
     m_retrans = 0;
     m_sackedOut = 0;
+    m_sackSeen = false;
     m_highestSack = std::make_pair(m_sentList.end(), SequenceNumber32(0));
 }
 
@@ -1273,6 +1268,7 @@
     {
         m_sackedOut = 0;
         m_lostOut = m_sentSize;
+        m_sackSeen = false;
         m_highestSack = std::make_pair(m_sentList.end(), SequenceNumber32(0));
     }
     else
@@ -1400,6 +1396,7 @@
     {
         (*it)->m_sacked = true;
         m_sackedOut += (*it)->m_packet->GetSize();
+        m_sackSeen = true;
         m_highestSack = std::make_pair(it, (*it)->m_startSeq);
         NS_LOG_INFO("Added a Reno SACK, status: " << *this);
     }
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.42/src/internet/model/tcp-tx-buffer.h ns-3.43/src/internet/model/tcp-tx-buffer.h
--- ns-3.42/src/internet/model/tcp-tx-buffer.h	2024-05-29 15:29:46.968073100 -0700
+++ ns-3.43/src/internet/model/tcp-tx-buffer.h	2024-10-09 16:41:09.892655800 -0700
@@ -2,18 +2,7 @@
  * Copyright (c) 2010-2015 Adrian Sai-wah Tam
  * Copyright (c) 2016 Natale Patriciello <natale.patriciello@gmail.com>
  *
- * This program is free software; you can redistribute it and/or modify
- * it under the terms of the GNU General Public License version 2 as
- * published by the Free Software Foundation;
- *
- * This program is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with this program; if not, write to the Free Software
- * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ * SPDX-License-Identifier: GPL-2.0-only
  *
  * Original author: Adrian Sai-wah Tam <adrian.sw.tam@gmail.com>
  */
@@ -499,7 +488,7 @@
      * The cases we need to manage are two, and they are depicted in the following
      * image:
      *
-     *\verbatim
+     * \verbatim
                          |------|     |----|     |----|
                   list = |      | --> |    | --> |    |
                          |------|     |----|     |----|
@@ -525,7 +514,7 @@
      * and we reduce case (2) to case (1) through sequentially applying fragment
      * or merge. For instance:
      *
-     *\verbatim
+     * \verbatim
         |------|
         |      |
         |------|
@@ -621,6 +610,7 @@
     uint32_t m_segmentSize{0};  //!< Segment size from TcpSocketBase
     bool m_renoSack{false};     //!< Indicates if AddRenoSack was called
     bool m_sackEnabled{true};   //!< Indicates if SACK is enabled on this connection
+    bool m_sackSeen{false};     //!< Indicates if a SACK was received
 
     static Callback<void, TcpTxItem*> m_nullCb; //!< Null callback for an item
 };
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.42/src/internet/model/tcp-tx-item.cc ns-3.43/src/internet/model/tcp-tx-item.cc
--- ns-3.42/src/internet/model/tcp-tx-item.cc	2024-05-29 15:29:46.968073100 -0700
+++ ns-3.43/src/internet/model/tcp-tx-item.cc	2024-10-09 16:41:09.892655800 -0700
@@ -1,18 +1,7 @@
 /*
  * Copyright (c) 2018 Natale Patriciello <natale.patriciello@gmail.com>
  *
- * This program is free software; you can redistribute it and/or modify
- * it under the terms of the GNU General Public License version 2 as
- * published by the Free Software Foundation;
- *
- * This program is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with this program; if not, write to the Free Software
- * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ * SPDX-License-Identifier: GPL-2.0-only
  *
  */
 #include "tcp-tx-item.h"
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.42/src/internet/model/tcp-tx-item.h ns-3.43/src/internet/model/tcp-tx-item.h
--- ns-3.42/src/internet/model/tcp-tx-item.h	2024-05-29 15:29:46.968073100 -0700
+++ ns-3.43/src/internet/model/tcp-tx-item.h	2024-10-09 16:41:09.892655800 -0700
@@ -1,18 +1,7 @@
 /*
  * Copyright (c) 2018 Natale Patriciello <natale.patriciello@gmail.com>
  *
- * This program is free software; you can redistribute it and/or modify
- * it under the terms of the GNU General Public License version 2 as
- * published by the Free Software Foundation;
- *
- * This program is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with this program; if not, write to the Free Software
- * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ * SPDX-License-Identifier: GPL-2.0-only
  *
  */
 #ifndef TCP_TX_ITEM_H
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.42/src/internet/model/tcp-vegas.cc ns-3.43/src/internet/model/tcp-vegas.cc
--- ns-3.42/src/internet/model/tcp-vegas.cc	2024-05-29 15:29:46.968073100 -0700
+++ ns-3.43/src/internet/model/tcp-vegas.cc	2024-10-09 16:41:09.892655800 -0700
@@ -1,18 +1,7 @@
 /*
  * Copyright (c) 2016 ResiliNets, ITTC, University of Kansas
  *
- * This program is free software; you can redistribute it and/or modify
- * it under the terms of the GNU General Public License version 2 as
- * published by the Free Software Foundation;
- *
- * This program is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with this program; if not, write to the Free Software
- * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ * SPDX-License-Identifier: GPL-2.0-only
  *
  * Author: Truc Anh N. Nguyen <annguyen@ittc.ku.edu>
  *
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.42/src/internet/model/tcp-vegas.h ns-3.43/src/internet/model/tcp-vegas.h
--- ns-3.42/src/internet/model/tcp-vegas.h	2024-05-29 15:29:46.968073100 -0700
+++ ns-3.43/src/internet/model/tcp-vegas.h	2024-10-09 16:41:09.892655800 -0700
@@ -1,18 +1,7 @@
 /*
  * Copyright (c) 2016 ResiliNets, ITTC, University of Kansas
  *
- * This program is free software; you can redistribute it and/or modify
- * it under the terms of the GNU General Public License version 2 as
- * published by the Free Software Foundation;
- *
- * This program is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with this program; if not, write to the Free Software
- * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ * SPDX-License-Identifier: GPL-2.0-only
  *
  * Author: Truc Anh N. Nguyen <annguyen@ittc.ku.edu>
  *
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.42/src/internet/model/tcp-veno.cc ns-3.43/src/internet/model/tcp-veno.cc
--- ns-3.42/src/internet/model/tcp-veno.cc	2024-05-29 15:29:46.968073100 -0700
+++ ns-3.43/src/internet/model/tcp-veno.cc	2024-10-09 16:41:09.892655800 -0700
@@ -1,18 +1,7 @@
 /*
  * Copyright (c) 2016 ResiliNets, ITTC, University of Kansas
  *
- * This program is free software; you can redistribute it and/or modify
- * it under the terms of the GNU General Public License version 2 as
- * published by the Free Software Foundation;
- *
- * This program is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with this program; if not, write to the Free Software
- * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ * SPDX-License-Identifier: GPL-2.0-only
  *
  * Author: Truc Anh N. Nguyen <annguyen@ittc.ku.edu>
  *
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.42/src/internet/model/tcp-veno.h ns-3.43/src/internet/model/tcp-veno.h
--- ns-3.42/src/internet/model/tcp-veno.h	2024-05-29 15:29:46.968073100 -0700
+++ ns-3.43/src/internet/model/tcp-veno.h	2024-10-09 16:41:09.892655800 -0700
@@ -1,18 +1,7 @@
 /*
  * Copyright (c) 2016 ResiliNets, ITTC, University of Kansas
  *
- * This program is free software; you can redistribute it and/or modify
- * it under the terms of the GNU General Public License version 2 as
- * published by the Free Software Foundation;
- *
- * This program is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with this program; if not, write to the Free Software
- * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ * SPDX-License-Identifier: GPL-2.0-only
  *
  * Author: Truc Anh N. Nguyen <annguyen@ittc.ku.edu>
  *
